/*
	W_File.c: Write and build a file to MiniOS7

	Compiler: BC++ 3.1
	          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)
             MSC 6.0,                                                             
             MSVC 1.52.    
             
	Compile mode: large
	Project: W_File.c	 
		      i7188.h	
                            
	Hardware: 7188xb
   Detail description:
      Build a text file to flash.
	
		[11/Aug/2014] by Vic
*/

#include <stdio.h>
#include <string.h>
#include "..\..\lib\7188xb.h"


void main(void)
{
   int disk=0; // DISK A
   int i,len;
   long freesize;
   long filesize=2000; //The value is free, you can set any value. 
   unsigned char buf[1024];
   FILE_DATA filedata;

   InitLib();

	//Get disk free size, if free size is too small, delete all files to get enough disk size.  
	freesize= OS7_GetDiskFreeSize(disk);
	Print("Free size is %lu bytes\r\n",freesize);
	Print("test %s\r\n",__DATE__);
	if(freesize<filesize){
		OS7_DeleteAllFile(disk);
	}
	i=OS7_OpenWriteFile(disk);
	if(!i){
		for(i=0;i<100;i++){
			len=sprintf(buf,"This is line %d\r\n",i+1);
			OS7_WriteFile(disk,buf,len);
		}
		//Don't set filedata.size, system will set it automatically 
   	// Set the time and date of file
   	OS7_FileDateTimeMode=0;
   	filedata.year=2014;
   	filedata.month=8;
   	filedata.day=11;
   	filedata.hour=11;
   	filedata.minute=30;
   	filedata.sec=8;
	
		strcpy(filedata.fname,"test1.txt");	
		OS7_CloseWriteFile(disk,&filedata);
	}
	else {
		Print("Can not Open a file for writing data,error=%d\r\n",i);
	}
	
}
