/*
Hello.c : Reads library version and flash memory size.

Compiler: BC++ 3.1, 
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)
          MSC 6.0,
          MSVC 1.52.
          
Compile mode: large

Project: Hello.c
         ..\Lib\(8000E.Lib,7188XAL.Lib,7188XBL.Lib,7188XL.Lib or 7188EL.Lib) 

Detail description:
    User can use MiniOs utility to load hello.exe to 7188XA/7188XB/7188XC/8000.

Hardware: 7188/8000

[24 May,2005] by Bill 
*/

#include"..\..\lib\7188xb.h"

void Run(char *cmd)   
{                     
    while(*cmd)       
    {                 
      Ungetch(*cmd++);
    }                 
    Ungetch('\r');    
}                     

void main(void)
{ 
    int iType,iVer;
    char *str="Runprog";
    
    InitLib();
    
    iType=Is7188Xb();
    
    if(iType)
    {
        iVer=GetLibVersion();
        Print("Hello 7188x! (Flash memory is %d K)\n\r",iType);
        Print("Library version is %d.%02d\n\r\n\r",iVer>>8,iVer&0xff);
        
        Run(str);
    }
    else
    {
        Print("Hello PC!, this program is not run under 7188X.");
    }
}