/*
LED.c: To use DelayMs function for LED ON/OFF.

Compiler: BC++ 3.1, 
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)
          MSC 6.0,
          MSVC 1.52.

Compile mode: Large

Project: LED.c
         ..\Lib\(8000E.Lib,7188XAL.Lib,7188XBL.Lib,7188XL.Lib or 7188EL.Lib)
         
Hordware: I-7188

Detail description:
    Function used:
        TimerOpen --> begin to use I-7188 timer
        TimerClose --> stop to use timer
        DelayMs  -->  delay time interval. unit is ms
    Press 'q' to quit program.
        
[07/Nov/2005] compiled by Liam
*/

#include<stdio.h>
#include"..\..\lib\7188xb.h"

void main(void)
{
    int LedMode=0;
    unsigned long value;
    int quit=0;
    
    Print("\n\rTest DelayMs() ...");
    Print("\n\rNow LED must flash once every second");
    Print("\n\rPress 'q' to quit\n\r");
    LedOff();
    while(!quit)
    {
        if(Kbhit())
        {
            switch(Getch())
            {
                case 'q':
                    quit=1;
                break;
            }
        }
        
        Delay(500);
        if(LedMode)
        {
            LedMode=0;
            LedOff();
        }
        else
        {
            LedMode=1;
            LedOn();
        }
    }
    LedOn();
}

