/*
Serial.c : To get 64-bit hardware unique serial number. 
                                                                           
Compiler: BC++ 3.1,                                                            
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)
          MSC 6.0,                                                             
          MSVC 1.52.                                                           
                                                                               
Compile mode: large                                                            
                                                                               
Project: serial.c                                                               
         ..\Lib\(8000E.Lib,7188XAL.Lib,7188XBL.Lib,7188XL.Lib or 7188EL.Lib)   
                                                                               
Hardware: 7188/8000

Detail description:
    The 64-bit hardware unique serial number is used to 
    protect use's software. Not every controller equips it. 
    You must check the detail specifics of the contorller. 
    
    You can type command 'Ver' under 7188> or i-8000> prompt to 
    list the number. If the controller doesn't equip a unique number,
    it shows 5A 5A 5A 5A 5A 5A 5A 5A.

[24 May,2005] by Bill
*/

#include"..\..\lib\7188Xb.h"
/*---------------------------------------------------------------------------------*/

void main(void)
{
    char cProtectID[8]={0x65,0x72,0x6e,0x61,0x6c,0x20,0x57,0x44};
    char cSerialNumber[8];
    int bSerialNumOk;
    int i,iRet;
    
    InitLib();
    
    bSerialNumOk=1; //Assume the ID is ok at beginning.
	iRet=GetSerialNumber(cSerialNumber);
    if(iRet==NoError)
    {
        for(i=0;i<8;i++)
        {
            if(cSerialNumber[i]!=cProtectID[i])
            {
                bSerialNumOk=0;
                break;
            }
        }    
    }
    
    if(bSerialNumOk)
        Print("ID Ok!\n\r");    
    else 
        Print("ID error!\n\r");
}