/*
X111Demo.c: Demo program for X111

Compiler: BC++ 3.1, 
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)

Compile mode: large

Project: X111Demo.c
         ..\..\Lib\7188xbl.lib
         ..\..\Lib\Xboard\X111.lib
         
Hardware: 7188XB + X111
X111: Digital Output: 13 Channels

Note: The address 0x0080 is not used.

[24/Oct/2003]
[05/July/2005] by Liam
*/

#include <stdio.h>
#include <dos.h>
#include "..\..\LIB\7188xb.h"
#include "..\..\LIB\Xboard\X111.h"

void main(void)
{
    int iAction, iStatus, iDOValue=0, iOutChannel, iRet, quit;
    
    InitLib();
    X111_Init();    //Initialize the X111

    Print("\n\r");
    Print("***************************************\n\r");
    Print("|    Demo program for 7188XB + X111   |\n\r");
    Print("|                                     |\n\r");
    Print("|            [05/July/2005]           |\n\r");
    Print("***************************************\n\r");

    while(iAction!=5)
    {
        iAction=0;
        quit=0;
        
        Puts("\n\r");
        Puts("1) Write DO (all channels)\n\r");
        Puts("2) Write DO (one channel)\n\r");
        Puts("3) DO Readback (all channels)\n\r");
        Puts("4) DO Readback (one channel)\n\r");
        Puts("\n\r");
        Puts("5) Quits demo program\n\r\n\r");
        Puts("Choose an option and press [Enter]:");
        Scanf("%d",&iAction);
        Puts("\n\r");
        
        switch(iAction)
        {
            //Write all Digital Output channels
            case 1:
                Print("Please input Output value(0 ~ 0x3f7f): ");
                Scanf("%x", &iDOValue);
                
                X111_Write_All_DO(iDOValue);

                Print("Output value=> 0x%04x\r\n\r\n", iDOValue);
            break;
            //Write single Digital Output channel
            case 2:
                Print("Please select outport channel(0~12) and status(0:OFF, 1:ON)\n\r");
                Print("Channel number and status:");
                
                Scanf("%d %d", &iOutChannel, &iStatus);
                
                if(iOutChannel>12)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                X111_Write_One_DO(iOutChannel, iStatus);
                
                Print("Channel %d ==> %s\r\n\r\n", iOutChannel, (iStatus>0)?"ON":"OFF");
            break;
            //Read all Digital Output channels
            case 3:
                iDOValue=X111_Read_All_DO();
                
                Print("Digital Output ReadBack=> 0x%04x\r\n\r\n", iDOValue);
            break;
            //Read single Digital Output channel
            case 4:
                Print("Please select outport channel(0~12): ");
                Scanf("%d", &iOutChannel);
                
                if(iOutChannel>12)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iRet=X111_Read_One_DO(iOutChannel);
                 
                if(iRet)
                    Print("Channel %d ==> ON\r\n\r\n", iOutChannel);
                else
                    Print("Channel %d ==> OFF\r\n\r\n", iOutChannel);
            break;
            
            case 5:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("Press any key to continue...\n\r");
            Getch();
        }
    }
}

