/*
X503Demo.c: Demo program for X503

Compiler: BC++ 3.1, 
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)

Compile mode: large

Project: X503Demo.c
         ..\..\Lib\7188xbl.lib
         
Hardware: 7188XB + X503
X503: COM3 (5-wire RS-232)

[14/July/2005] by Liam
*/

#include <stdio.h>
#include <string.h>
#include "..\..\lib\7188xb.h"

#define BUFSIZE 1024

char OutpBuf[BUFSIZE], InpBuf[BUFSIZE];

void main(void)
{
    int idata, iAction, iValue, quit;
    
    InitLib();
    InstallCom(3, 115200L, 8, 0, 1);
    
    Print("\n\r");
    Print("****************************************\n\r");
    Print("|             7188XB + X503            |\n\r");
    Print("****************************************\n\r");
    
    while(iAction!=4)
    {
        iAction=0;
        quit=0;
        
        Print("\n\r");
        Print("1) Send & Receive data to/from COM3:\n\r");
        Print("2) Set RTS status \n\r");
        Print("3) Get CTS status (0: CTS off, 1: CTS ON)\n\r");
        Print("\n\r");
        Print("4) Quits Demo program\n\r\n\r");
        Print("Choose an option and press [Enter]:");
        Scanf("%d",&iAction);
        
        switch(iAction)
        {
            // Send & Receive data to/from COM3
            case 1:
                Print("\n\r");
                Print("Send & Receive data to/from COM3\n\r");
                Print("Enter a string to COM port:");
                Scanf("%s",&OutpBuf);
                ToComStr(3,OutpBuf);
                Delay(2);
                idata=ReadComn(3,InpBuf,BUFSIZE);
                InpBuf[idata]=0x0;
                Print("Read COM port==>%s,idata=%d\r\n",InpBuf,idata);
                if(!strcmp(OutpBuf,InpBuf))
                    Print("Send COM3 <==> Receiv COM3 -->Test OK\r\n");
                else
                    Print("Send COM3 <==> Receiv COM3 -->Test error\r\n");
            break;
            // Set RTS status
            case 2:
                Print("\r\n");
                Print("Input 0 or 1? ");
                Scanf("%d", &iValue);
                if(iValue)
                    SetRtsActive_3();
                else
                    SetRtsInactive_3();
                Print("\r\nThe RTS status is %d\r\n", iValue);
            break;
            // Get CTS status
            case 3:
                Print("\n\rCTS status of COM3 is:%d\r\n", GetCtsStatus_3());
            break;
            
            case 4:
                quit=1;
                RestoreCom(3);
            break;
            default:
                quit=1;
            break;
        }
        if(quit!=1)
        {
            Print("\r\nPress any key to continue...\r\n");
            Getch();
        }
    }
}
