/*
X511Demo.c: Demo program for X511

Compiler: BC++ 3.1, 
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)

Compile mode: large

Project: X511Demo.c
         ..\..\Lib\7188xbl.lib
         
Hardware: 7188XB + X511
X511: COM3 (Data+,Data- RS-485)
      COM4 (Data+,Data- RS-485)
      COM5 (Data+,Data- RS-485)

[21/July/2005] by Liam
*/

#include <stdio.h>
#include <string.h>
#include "..\..\lib\7188xb.h"

#define BUFSIZE 256

char OutpBuf[BUFSIZE], InpBuf[BUFSIZE];

void main(void)
{
    int idata, iAction, iValue, quit;
    
    InitLib();
    InstallCom(3, 115200L, 8, 0, 1);
    InstallCom(4, 115200L, 8, 0, 1);
    InstallCom(5, 115200L, 8, 0, 1);

    Print("\r\n");
    Print("****************************************\r\n");
    Print("|             7188XB + X511            |\r\n");
    Print("****************************************\r\n");
       
    while(iAction!=4)
    {
        iAction=0;
        quit=0;
        
        Print("\r\n");
        Print("1) Test COM3 (Data+,Data- RS-485)\r\n");
        Print("2) Test COM4 (Data+,Data- RS-485)\r\n");
        Print("3) Test COM5 (Data+,Data- RS-485)\r\n");
        Print("\r\n");
        Print("4) Quits Demo program\r\n\r\n");
        Print("Choose an option and press [Enter]:");
        Scanf("%d", &iAction);
        
        switch(iAction)
        {
            // FOR COM3
            case 1:
                Print("\r\n");
                Print("Send & Receive data to/from COM3\r\n");
                Print("Enter a string to COM port:");
                Scanf("%s", &OutpBuf);
                ToComStr(3, OutpBuf);
                Delay(2);
                idata=ReadComn(3, InpBuf, BUFSIZE);
                InpBuf[idata]=0x0;
                Print("Read COM port==>%s,idata=%d\r\n", InpBuf, idata);
                if(!strcmp(OutpBuf, InpBuf))
                    Print("Send COM3 <==> Receiv COM3 -->Test OK\r\n");
                else
                    Print("Send COM3 <==> Receiv COM3 -->Test error\r\n");
                break;
            // FOR COM4
            case 2:
                Print("\r\n");
                Print("Send & Receive data to/from COM4\r\n");
                Print("Enter a string to COM port:");
                Scanf("%s", &OutpBuf);
                ToComStr(4, OutpBuf);
                Delay(2);
                idata=ReadComn(4, InpBuf, BUFSIZE);
                InpBuf[idata]=0x0;
                Print("Read COM port==>%s, idata=%d\r\n", InpBuf, idata);
                if(!strcmp(OutpBuf, InpBuf))
                    Print("Send COM4 <==> Receiv COM4 -->Test OK\r\n");
                else
                    Print("Send COM4 <==> Receiv COM4 -->Test error\r\n");
                break;
            // FOR COM5
            case 3:
                Print("\r\nSend & Receive data to/from COM5\r\n");
                Print("Enter a string to COM port:");
                Scanf("%s", &OutpBuf);
                ToComStr(5, OutpBuf);
                Delay(2);
                idata=ReadComn(5, InpBuf, BUFSIZE);
                InpBuf[idata]=0x0;
                Print("Read COM port==>%s, idata=%d\r\n", InpBuf, idata);
                if(!strcmp(OutpBuf, InpBuf))
                    Print("Send COM5 <==> Receiv COM5 -->Test OK\r\n");
                else
                    Print("Send COM5 <==> Receiv COM5 -->Test error\r\n");
            break;
            case 4:
                quit=1;
                RestoreCom(3);
                RestoreCom(4);
                RestoreCom(5);
            break;
            default :
                quit=1;
            break;
        }
        if(quit!=1)
        {
            Print("\r\nPress any key to continue...\r\n");
            Getch();
        }
    }
}
