/*
X107Demo.c: Demo program for X107

Compiler: MSC 6.0
          MSVC 1.52

Compile mode: large

Project: X107Demo.c
         ..\..\Lib\7188xbl.lib
         ..\..\Lib\Xboard\X107.lib
         
Hardware: 7188XB + X107
X107:
    Digital Input : 6 Channels
    Digital Output: 7 Channels

[03/Sep/2002]
[08/July/2005] by Liam
*/

#include <conio.h>
#include "..\..\lib\7188xb.h"
#include "..\..\lib\Xboard\X107.h"

void main(void)
{
    int iAction, iStatus, iDIValue, iDOValue=0, iRet, quit;
    int iInChannel, iOutChannel;
    char buf[100];

    InitLib();
    X107_Init();    //Initialize the X107
    
    Print("\r\n");
    Print("****************************************\r\n");
    Print("|     Demo program for 7188XB + X107   |\r\n");
    Print("|                                      |\r\n");
    Print("|            [05/July/2005]            |\r\n");
    Print("****************************************\r\n");

    while(iAction!=7)
    {
        iAction=0;
        quit=0;
        
        Puts("\r\n");
        Puts("1) Read DI (all channels)\r\n");
        Puts("2) Read DI (one channel)\r\n");
        Puts("3) Write DO (all channels)\r\n");
        Puts("4) Write DO (one channel)\r\n");
        Puts("5) DO Readback (all channels)\r\n");
        Puts("6) DO Readback (one channel)\r\n");
        Puts("\r\n");
        Puts("7) Quits demo program\r\n\r\n");
        Puts("Choose an option and press [Enter]:");
        LineInput(buf, 99);
        sscanf(buf, "%d", &iAction);
        Puts("\r\n");
        
        switch(iAction)
        {
            //Read all DI ReadBack
            case 1:
                iDIValue=X107_Read_All_DI();
                
                Print("Input value=> 0x%02x\r\n\r\n", iDIValue);
            break;
            //Read single DI ReadBack
            case 2:
                Print("Please select inport channel(0~5): ");
                LineInput(buf,99);
                sscanf(buf, "%d", &iInChannel);
                
                if(iInChannel>5)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iDIValue=X107_Read_One_DI(iInChannel);
                
                if(iDIValue)
                    Print("Channel %d ==> OFF\r\n\r\n", iInChannel);
                else
                    Print("Channel %d ==> ON\r\n\r\n", iInChannel);
            break;
            //Write all DO channels
            case 3:
                Print("Please input Output value(0 ~ 0x7f): ");
                LineInput(buf,99);
                sscanf(buf, "%x", &iDOValue);
                
                X107_Write_All_DO(iDOValue);

                Print("Output value=> 0x%02x\r\n\r\n", iDOValue);
            break;
            //Write single DO channel
            case 4:
                Print("Please select outport channel(0~6) and status(0:OFF, 1:ON)\r\n");
                Print("Channel number and status:");
                
                LineInput(buf,99);
                sscanf(buf, "%d %d", &iOutChannel, &iStatus);
                
                if(iOutChannel>6)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                X107_Write_One_DO(iOutChannel, iStatus);
                                
				Print("Channel %d ==> %s\r\n\r\n", iOutChannel, (iStatus>=1)?"ON":"OFF");
            break;
            //Read all DO ReadBack
            case 5:
                iDOValue=X107_Read_All_DO();
                
                Print("Digital Output ReadBack=> 0x%02x\r\n\r\n", iDOValue);
            break;
            //Read single DO ReadBack
            case 6:
                Print("Please select outport channel(0~6): ");
                LineInput(buf,99);
                sscanf(buf, "%d", &iOutChannel);
                
                if(iOutChannel>6)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iRet=X107_Read_One_DO(iOutChannel);
                 
                if(iRet)
                    Print("Channel %d ==> ON\r\n\r\n", iOutChannel);
                else
                    Print("Channel %d ==> OFF\r\n\r\n", iOutChannel);
            break;
            case 7:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("Press any key to continue...\r\n");
            Getch();
        }
    }
}
