/*
X109Demo.c: Demo program for X109

Compiler: MSC 6.0
          MSVC 1.52

Compile mode: large

Project: X109Demo.c
         ..\..\Lib\7188xbl.lib
         ..\..\lib\Xboard\X109.lib
         
Hardware: 7188XB + X109
X109: 7 channels PhotoMOS Relay

[10/Oct/2003]
[15/July/2005] by Liam
*/

#include <stdio.h>
#include <dos.h>
#include "..\..\LIB\7188xb.h"
#include "..\..\lib\Xboard\X109.h"

void main(void)
{
    int iAction, iStatus, iDOValue=0, iOutChannel, iRet, quit;
    char buf[100];
    
    InitLib();
    X109_Init();    //Initialize the X109

    Print("\r\n");
    Print("***************************************\r\n");
    Print("|    Demo program for 7188XB + X109   |\r\n");
    Print("|                                     |\r\n");
    Print("|            [15/July/2005]           |\r\n");
    Print("***************************************\r\n");

    while(iAction!=5)
    {
        iAction=0;
        quit=0;
        
        Puts("\r\n");
        Puts("1) Write Relay output (all channels)\r\n");
        Puts("2) Write Relay output (one channel)\r\n");
        Puts("3) Relay output Readback (all channels)\r\n");
        Puts("4) Relay output Readback (one channel)\r\n");
        Puts("\r\n");
        Puts("5) Quits demo program\r\n\r\n");
        Puts("Choose an option and press [Enter]:");
        LineInput(buf,99);
        sscanf(buf, "%d", &iAction);
        Puts("\r\n");

        switch(iAction)
        {
            // Write Relay output (all channels)
            case 1:
                Print("Please input Output value(0 ~ 0x7f): ");
                LineInput(buf,99);
                sscanf(buf, "%x", &iDOValue);
                
                X109_Write_All_DO(iDOValue);

                Print("Output value=> 0x%02x\r\n\r\n", iDOValue);
            break;
            // Write Relay output (one channel)
            case 2:
                Print("Please select outport channel(0~6) and status(0:OFF, 1:ON)\r\n");
                Print("Channel number and status:");
                
                LineInput(buf,99);
                sscanf(buf, "%d %d", &iOutChannel, &iStatus);
                
                if(iOutChannel>6)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                X109_Write_One_DO(iOutChannel, iStatus);
                                
                Print("Channel %d ==> %s\r\n\r\n", iOutChannel, (iStatus>=1)?"ON":"OFF");
            break;
            // Relay output Readback (all channels)
            case 3:
                iDOValue=X109_Read_All_DO();
                
                Print("Digital Output ReadBack=> 0x%02x\r\n\r\n", iDOValue);
            break;
            // Relay output Readback (one channels)
            case 4:
                Print("Please select outport channel(0~6): ");
                LineInput(buf,99);
                sscanf(buf, "%d", &iOutChannel);
                
                if(iOutChannel>6)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iRet=X109_Read_One_DO(iOutChannel);
                 
                if(iRet)
                    Print("Channel %d ==> ON\r\n\r\n", iOutChannel);
                else
                    Print("Channel %d ==> OFF\r\n\r\n", iOutChannel);
            break;
            
            case 5:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("Press any key to continue...\r\n");
            Getch();
        }
    }
}

