/*
X110Demo.c: Demo program for X110

Compiler: MSC 6.0
          MSVC 1.52

Compile mode: large

Project: X110Demo.c
         ..\..\Lib\7188xbl.lib
         
Hardware: 7188XB + X110
X110:
    Digital Input: 14 Channels
    
[24/Oct/2002]
[11/July/2005] by Liam
*/

#include <conio.h>
#include "..\..\LIB\7188xb.h"
#include "..\..\LIB\Xboard\X110.h"

void main(void)
{
    int iAction, iDIValue, iInChannel, quit;
    char buf[100];
    
    InitLib();
    X110_Init();    //Initialize the X110
    
    Print("\r\n");
    Print("***************************************\r\n");
    Print("|    Demo program for 7188XB + X110   |\r\n");
    Print("|                                     |\r\n");
    Print("|           [11/July/2005]            |\r\n");
    Print("***************************************\r\n");

    while(iAction!=3)
    {
        iAction=0;
        quit=0;
        
        Puts("\r\n");
        Puts("1) Read DI (all channels)\r\n");
        Puts("2) Read DI (one channel)\r\n");
        Puts("\r\n");
        Puts("3) Quits demo program\r\n\r\n");
        Puts("Choose an option and press [Enter]:");
        LineInput(buf, 99);
        sscanf(buf, "%d", &iAction);
        Puts("\r\n");
        
        switch(iAction)
        {
            //Read all DI ReadBack
            case 1:
                iDIValue=X110_Read_All_DI();
                
                Print("Input value=> 0x%04x\r\n\r\n", iDIValue);
            break;
            //Read single DI ReadBack
            case 2:
                Print("Please select inport channel(0~13): ");
                LineInput(buf, 99);
                sscanf(buf, "%d", &iInChannel);
                
                if(iInChannel>13)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iDIValue=X110_Read_One_DI(iInChannel);
                
                if(iDIValue)
                    Print("Channel %d ==> OFF\r\n\r\n", iInChannel);
                else
                    Print("Channel %d ==> ON\r\n\r\n", iInChannel);                    
            break;
            case 3:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("Press any key to continue...\r\n");
            Getch();
        }
    }
}
