/*
X111Demo.c: Demo program for X111

Compiler: MSC 6.0
          MSVC 1.52

Compile mode: large

Project: X111Demo.c
         ..\..\Lib\7188xbl.lib
         ..\..\Lib\Xboard\X111.lib
         
Hardware: 7188XB + X111
X111:
    Digital Output: 13 Channels

Note:
    The address 0x0080 is not used.

[24/Oct/2003]
[08/July/2005] by Liam
*/

#include <stdio.h>
#include <dos.h>
#include "..\..\LIB\7188xb.h"
#include "..\..\LIB\Xboard\X111.h"

void main(void)
{
    int iAction, iStatus, iDOValue=0, iOutChannel, iRet, quit;
    char buf[100];
    
    InitLib();
    X111_Init();    //Initialize the X111

    Print("\r\n");
    Print("***************************************\r\n");
    Print("|    Demo program for 7188XB + X111   |\r\n");
    Print("|                                     |\r\n");
    Print("|            [05/July/2005]           |\r\n");
    Print("***************************************\r\n");

    while(iAction!=5)
    {
        iAction=0;
        quit=0;
        
        Puts("\r\n");
        Puts("1) Write DO (all channels)\r\n");
        Puts("2) Write DO (one channel)\r\n");
        Puts("3) DO Readback (all channels)\r\n");
        Puts("4) DO Readback (one channel)\r\n");
        Puts("\r\n");
        Puts("5) Quits demo program\r\n\r\n");
        Puts("Choose an option and press [Enter]:");
        LineInput(buf, 99);
        sscanf(buf, "%d", &iAction);
        Puts("\r\n");
        
        switch(iAction)
        {
            //Write all Digital Output channels
            case 1:
                Print("Please input Output value(0 ~ 0x3f7f): ");
                LineInput(buf, 99);
                sscanf(buf, "%x", &iDOValue);
                
                X111_Write_All_DO(iDOValue);

                Print("Output value=> 0x%04x\r\n\r\n", iDOValue);
            break;
            //Write single Digital Output channel
            case 2:
                Print("Please select outport channel(0~12) and status(0:OFF, 1:ON)\r\n");
                Print("Channel number and status:");
                
                LineInput(buf, 99);
                sscanf(buf, "%d %d", &iOutChannel, &iStatus);
                
                if(iOutChannel>12)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                X111_Write_One_DO(iOutChannel, iStatus);
                                
                Print("Channel %d ==> %s\r\n\r\n", iOutChannel, (iStatus>=1)?"ON":"OFF");
            break;
            //Read all Digital Output channels
            case 3:
                iDOValue=X111_Read_All_DO();
                
                Print("Digital Output ReadBack=> 0x%04x\r\n\r\n", iDOValue);
            break;
            //Read single Digital Output channel
            case 4:
                Print("Please select outport channel(0~12): ");
                LineInput(buf,99);
                sscanf(buf, "%d", &iOutChannel);
                
                if(iOutChannel>12)
                {
                    Puts("Unknow Channel Number!!\r\n\r\n");
                    break;
                }
                
                iRet=X111_Read_One_DO(iOutChannel);
                 
                if(iRet)
                    Print("Channel %d ==> ON\r\n\r\n", iOutChannel);
                else
                    Print("Channel %d ==> OFF\r\n\r\n", iOutChannel);
            break;
            
            case 5:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("Press any key to continue...\r\n");
            Getch();
        }
    }
}

