/*
X505Demo.c: Demo program for X505

Compiler: MSC 6.0
          MSVC 1.52

Compile mode: large

Project: X505Demo.c
         ..\..\Lib\7188xbl.lib
         
Hardware: 7188XB + X505
X505: COM3 (5-wire RS-232)
      COM4 (5-wire RS-232)
      COM5 (5-wire RS-232)

[08/July/2005] by Liam
*/

#include <stdio.h>
#include <string.h>
#include "..\..\lib\7188xb.h"

#define BUFSIZE 1024

char OutpBuf[BUFSIZE], InpBuf[BUFSIZE];

void main(void)
{
    int idata, iAction, iValue, quit;
    char buf[100];
    
    InitLib();
    
    InstallCom(3, 115200L, 8, 0, 1);
    InstallCom(4, 115200L, 8, 0, 1);
    InstallCom(5, 115200L, 8, 0, 1);

    Print("\r\n");
    Print("****************************************\r\n");
    Print("|             7188XB + X505            |\r\n");
    Print("****************************************\r\n");
    
    while(iAction!=4)
    {
        iAction=0;
        quit=0;
        
        Print("\r\n");
        Print("1) Test COM3 (5-wire RS-232)\r\n");
        Print("2) Test COM4 (5-wire RS-232)\r\n");
        Print("3) Test COM5 (5-wire RS-232)\r\n");
        Print("\r\n");
        Print("4) Quits Demo program\r\n\r\n");
        Print("Choose an option and press [Enter]:");
        LineInput(buf, 99);
        sscanf(buf, "%d", &iAction);
        
        switch(iAction)
        {
            // FOR COM3
            case 1:
                for(;;)
                {
                    Print("\r\n");
                    Print("1) Send & Receive data to/from COM3:\r\n");
                    Print("2) Set RTS status \r\n");
                    Print("3) Get CTS status (0: CTS off, 1: CTS ON)\r\n");
                    Print("4) Quit COM3 test\r\n");
                    Print("Choose an option:");
                    LineInput(buf, 99);
                    sscanf(buf, "%d", &iValue);
                    
                    switch(iValue)
                    {
                        case 1:
                            Print("\r\n");
                            Print("Send & Receive data to/from COM3\r\n");
                            Print("Enter a string to COM port:");
                            LineInput(buf, 99);
                            sscanf(buf, "%s", &OutpBuf);
                            ToComStr(3, OutpBuf);
                            Delay(2);
                            idata=ReadComn(3, InpBuf, BUFSIZE);
                            InpBuf[idata]=0x0;
                            Print("Read COM port==>%s,idata=%d\r\n", InpBuf, idata);
                            if(!strcmp(OutpBuf, InpBuf))
                                Print("Send COM3 <==> Receiv COM3 -->Test OK\r\n");
                            else
                                Print("Send COM3 <==> Receiv COM3 -->Test error\r\n");
                            break;
                        case 2:
                            Print("\r\n");
                            Print("Input 0 or 1? ");
                            LineInput(buf, 99);
                            sscanf(buf, "%d", &iValue);
                            if(iValue)
                                SetRtsActive_3();
                            else
                                SetRtsInactive_3();
                            Print("\n\rThe RTS status is %d\r\n", iValue);
                            break;
                        case 3:
                            Print("\n\rCTS status of COM3 is:%d\r\n", GetCtsStatus_3());
                            break;
                        case 4:
                            quit=1;
                            break;
                    }
                    if(quit==1)
                        break;
                    else
                    {
                        Print("\n\rPress any key to continue...\r\n");
                        Getch();
                    }
                }
                break;
            // FOR COM4
            case 2:
                for(;;)
                {
                    Print("\r\n");
                    Print("1) Send & Receive data to/from COM4:\r\n");
                    Print("2) Set RTS status \r\n");
                    Print("3) Get CTS status (0: CTS off, 1: CTS ON)\r\n");
                    Print("4) Quit COM4 test\r\n");
                    Print("Choose an option:");
                    LineInput(buf, 99);
                    sscanf(buf, "%d", &iValue);
                    
                    switch(iValue)
                    {
                        case 1:
                            Print("\r\n");
                            Print("Send & Receive data to/from COM4\r\n");
                            Print("Enter a string to COM port:");
                            LineInput(buf, 99);
                            sscanf(buf, "%s", &OutpBuf);
                            ToComStr(4, OutpBuf);
                            Delay(2);
                            idata=ReadComn(4, InpBuf, BUFSIZE);
                            InpBuf[idata]=0x0;
                            Print("Read COM port==>%s,idata=%d\r\n", InpBuf, idata);
                            if(!strcmp(OutpBuf,InpBuf))
                                Print("Send COM4 <==> Receiv COM4 -->Test OK\r\n");
                            else
                                Print("Send COM4 <==> Receiv COM4 -->Test error\r\n");
                            break;
                        case 2:
                            Print("\r\n");
                            Print("Input 0 or 1? ");
                            LineInput(buf, 99);
                            sscanf(buf, "%d", &iValue);
                            if(iValue)
                                SetRtsActive_4();
                            else
                                SetRtsInactive_4();
                            Print("\r\nThe RTS status is %d\r\n", iValue);
                            break;
                        case 3:
                            Print("\r\nCTS status of COM4 is:%d\r\n", GetCtsStatus_4());
                            break;
                        case 4:
                            quit=1;
                            break;
                    }
                    if(quit==1)
                        break;
                    else
                    {
                        Print("\r\nPress any key to continue...\r\n");
                        Getch();
                    }
                }
                break;
            // FOR COM5
            case 3:
                for(;;)
                {
                    Print("\r\n");
                    Print("1) Send & Receive data to/from COM5:\r\n");
                    Print("2) Set RTS status \r\n");
                    Print("3) Get CTS status (0: CTS off, 1: CTS ON)\r\n");
                    Print("4) Quit COM5 test\r\n");
                    Print("Choose an option:");
                    LineInput(buf, 99);
                    sscanf(buf, "%d", &iValue);
                    
                    switch(iValue)
                    {
                        case 1:
                            Print("\r\nSend & Receive data to/from COM5\r\n");
                            Print("Enter a string to COM port:");
                            LineInput(buf, 99);
                            sscanf(buf, "%s", &OutpBuf);
                            ToComStr(5, OutpBuf);
                            Delay(2);
                            idata=ReadComn(5, InpBuf, BUFSIZE);
                            InpBuf[idata]=0x0;
                            Print("Read COM port==>%s,idata=%d\r\n", InpBuf, idata);
                            if(!strcmp(OutpBuf,InpBuf))
                                Print("Send COM5 <==> Receiv COM5 -->Test OK\r\n");
                            else
                                Print("Send COM5 <==> Receiv COM5 -->Test error\r\n");
                            break;
                        case 2:
                            Print("\r\n");
                            Print("Input 0 or 1? ");
                            LineInput(buf,99);
                            sscanf(buf, "%d", &iValue);
                            if(iValue)
                                SetRtsActive_5();
                            else
                                SetRtsInactive_5();
                            Print("\r\nThe RTS status is %d\r\n", iValue);
                            break;
                        case 3:
                            Print("\r\nCTS status of COM5 is:%d\r\n", GetCtsStatus_5());
                            break;
                        case 4:
                            quit=1;
                            break;
                    }
                    if(quit==1)
                        break;
                    else
                    {
                        Print("\r\nPress any key to continue...\r\n");
                        Getch();
                    }
                }
                break;
            case 4:
                quit=1;
                RestoreCom(3);
                RestoreCom(4);
                RestoreCom(5);
            break;
        }
        if(quit!=1)
        {
            Print("\r\nPress any key to continue...\r\n");
            Getch();
        }
    }
}
