/*
X703funsDemo.c: Demo program for X703

Compiler: BC++ 3.1
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum) 
          
Compile mode: large

Project: X703funsDemo.
         ..\..\..\..\lib\7188xbl.lib
         ..\..\..\..\lib\XBoard\X703.lib
     
Hardware: 7188XB + X703

[16/Oct/2008] by Vic
*/

/********************************************************************************/
/*  X703:   3-axis encoder counter                          */
/********************************************************************************/


#include <stdlib.h>
#include <dos.h>
#include "..\..\..\..\lib\7188xb.h"
#include "..\..\..\..\lib\XBoard\x703.h"

void Show_ABZ(int);

void main(void)
{
   char data;
   int i,LibVer,ch=3,hwID,LatticeVer,read32bit=0;
   int xor[3],tmpxor,mode[3],tmpmode;
   long EncVal[3];
   unsigned char LibDate;

   InitLib();
   X703_Init();
   
   hwID=X703_GetHardwareID();
   Print("\nHardware ID is 0x%x",hwID);
   
   LatticeVer=X703_GetLatticeVersion();
   if(LatticeVer>0) Print("\nLattice Version=%04x",LatticeVer);
   else Print("\nThe hardware can't use X703_GetLatticeVersion()");
   
   LibVer=X703_GetLibVersion();
   Print("\nLibrary version=%04x",LibVer);
    
   X703_GetLibDate(&LibDate);
   Print("\nLibrary date=%02x",LibDate);
   
   for(i=0;i<ch;i++){
      Print("\nxor%d=(0 or 1)?",i+1);
      xor[i]=Getch()-'0'; if(xor[i]) xor[i]=1;
   
      X703_SetXOR(i+1,xor[i]);
try_again:      
      Print("\nmode%d = (1=cw/ccw,2=pulse/dir,3=a/b) ?",i+1);
      mode[i]=Getch()-'0';
      if(mode[i]<1 || mode[i]>3) goto try_again;
      X703_SetMode(i+1,mode[i]);
   }
   
   for(i=0;i<ch;i++){
      X703_GetMode(i+1,&tmpmode);
      if(tmpmode!=mode[i]){
         Print("\nX703_GetMode() function error(%02X)\n",tmpmode);
         exit(1);
      }
   }
   
   for(i=0;i<ch;i++){
      X703_GetXOR(i+1, &tmpxor);
      if(tmpxor!=xor[i]) {
         Print("\nX703_GetXOR() function error\n");
         exit(1);
      }
   }

   for(;;){
      if(Kbhit()) {
         data=Getch(); 
         if(data=='a') X703_ResetEncoder(1);
         else if(data=='b') X703_ResetEncoder(2);
         else if(data=='c') X703_ResetEncoder(3);
         else if(data=='d' && hwID==0x73) read32bit=1;
         else if(data=='e') read32bit=0;
         else return;
      }
      
      if(read32bit){
         for(i=0;i<ch;i++){
            X703_Read32BitEncoder(i+1,EncVal+i);
            Print("\nxor%d=%d enc%d=%lx mode%d=%d ",i+1,xor[i],i+1,EncVal[i],i+1,mode[i]);
            Show_ABZ(i+1);
         }
      }
      else{
         for(i=0;i<ch;i++){
            X703_Read24BitEncoder(i+1,EncVal+i);
            Print("\nxor%d=%d enc%d=%lx mode%d=%d ",i+1,xor[i],i+1,EncVal[i],i+1,mode[i]);
            Show_ABZ(i+1);
         }
      }
      
      Print("\n");
      DelayMs(100);
   }

}

void Show_ABZ(int ch)
{
   int index;
   int A,B,Z,ret;       
   
   X703_GetLineStatus(ch,&A,&B,&Z);
   
   X703_GetIndex(ch,&index);
   if(index!=Z) {
      Print("\nX703_GetIndex() function error\n");
      exit(1);
   }
   
   Print("Z%dB%dA%d=%d%d%d ",ch,ch,ch,Z,B,A);
}
